package sun.security.util;

import java.nio.CharBuffer;
import java.nio.ByteBuffer;
import java.nio.charset.CodingErrorAction;
import sun.misc.SharedSecrets;
import java.io.Console;
import java.util.Arrays;
import java.io.PushbackInputStream;
import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.nio.charset.CharsetEncoder;

public class Password
{
    private static volatile CharsetEncoder enc;
    
    public Password() {
    }
    
    public static char[] readPassword(InputStream inputStream) throws IOException {
        return readPassword(inputStream, false);
    }
    
    public static char[] readPassword(InputStream in, boolean b) throws IOException {
        char[] password = null;
        byte[] convertToBytes = null;
        try {
            Console console;
            if (!b && in == System.in && (console = System.console()) != null) {
                password = console.readPassword();
                if (password != null && password.length == 0) {
                    __Null _Null = null;
                }
                else {
                    convertToBytes = convertToBytes(password);
                    in = new ByteArrayInputStream(convertToBytes);
                }
            }
            char[] a2;
            char[] a = a2 = new char[128];
            int length = a2.length;
            int n = 0;
            int i = 0;
            while (i == 0) {
                int read;
                switch (read = in.read()) {
                    case -1:
                    case 10: {
                        i = 1;
                        continue;
                    }
                    case 13: {
                        int read2 = in.read();
                        if (read2 != 10 && read2 != -1) {
                            if (!(in instanceof PushbackInputStream)) {
                                in = new PushbackInputStream(in);
                            }
                            ((PushbackInputStream)in).unread(read2);
                            break;
                        }
                        else {
                            i = 1;
                            continue;
                        }
                    }
                }
                if (--length < 0) {
                    a2 = new char[n + 128];
                    length = a2.length - n - 1;
                    System.arraycopy(a, 0, a2, 0, n);
                    Arrays.fill(a, ' ');
                    a = a2;
                }
                a2[n++] = (char)read;
            }
            if (n == 0) {
                __Null _Null2 = null;
            }
            else {
                char[] array = new char[n];
                System.arraycopy(a2, 0, array, 0, n);
                Arrays.fill(a2, ' ');
            }
        }
        finally {
            if (password != null) {
                Arrays.fill(password, ' ');
            }
            if (convertToBytes != null) {
                Arrays.fill(convertToBytes, (byte)0);
            }
        }
    }
    
    private static byte[] convertToBytes(char[] array) {
        if (Password.enc == null) {
            synchronized (Password.class) {
                Password.enc = SharedSecrets.getJavaIOAccess().charset().newEncoder().onMalformedInput(CodingErrorAction.REPLACE).onUnmappableCharacter(CodingErrorAction.REPLACE);
            }
        }
        byte[] array2 = new byte[(int)(Password.enc.maxBytesPerChar() * (float)array.length)];
        ByteBuffer wrap = ByteBuffer.wrap(array2);
        synchronized (Password.enc) {
            Password.enc.reset().encode(CharBuffer.wrap(array), wrap, true);
        }
        if (wrap.position() < array2.length) {
            array2[wrap.position()] = 10;
            return array2;
        }
        return array2;
    }
}
